unit int_def;

interface


const
    {Typy zminnyh}
     c_typ_int='i';
     c_typ_real='r';
     c_typ_string='s';
     c_typ_pointer='p';
     c_typ_class='c';
     c_typ_textfile='t';

     c_typ_int_full='integer';
     c_typ_real_full='real';
     c_typ_string_full='string';
     c_typ_pointer_full='pointer';
     c_typ_class_full='class';
     c_typ_textfile_full='textfile';


type
    {Slujbovi typy danyh}
     TIdentyfikator=string{[15]};
     TPIdentyfikator=^string;
     TTypString=string[2];
    {Opys typu danyh shcho vidpovidaye za zminni}
     TPZminnaZapys=^TZminnaZapys;
     TZminnaZapys=record
       typ:TTypString;
       imya:TPIdentyfikator;
       znachennia:pointer;
       next:TPZminnaZapys;
       rozmir:word;
     end;
    {Opys typu yakyi vidpovidaye za spysok procedur}
     TPProcedureZapys=^TProcedureZapys;
     TProcedureZapys=record
       nazva:TPIdentyfikator;
       parametry:TPIdentyfikator;
       pozyciya:longint;              {pozyciya procedury v programi}
       next:TPProcedureZapys;
     end;



function IsIdentyfikator(param:string):boolean;
function GetStringZnachennia(s:string):string;
function IsOperation(s:string):boolean;
function IsLogicOperation(s:string):boolean;
function GetConstType(param:string):TTypString;
function GetPointerOfVar(name:string; zminniFirst:TPZminnaZapys):pointer;
function ConvertToSpecialChars(s:string):string;
function ConvertFromSpecialChars(s:string):string;


implementation

function IsIdentyfikator(param:string):boolean;
begin
   if param[1]>='A' then IsIdentyfikator:=true
    else IsIdentyfikator:=false;
end;

function IsOperation(s:string):boolean;
begin
  if
     (s='+') or
     (s='-') or
     (s='*') or
     (s='/') or
     (s='and') or
     (s='or') or
     (s='not') or
     (s='<') or
     (s='>') or
     (s='=') or
     (s='<>') or
     (s='>=') or
     (s='<=') or
     (s='-u')
  then
     IsOperation:=true
  else
     IsOperation:=false;
end;

function IsLogicOperation(s:string):boolean;
begin
  if
     (s='and') or
     (s='or') or
     (s='not') or
     (s='<') or
     (s='>') or
     (s='=') or
     (s='<>') or
     (s='>=') or
     (s='<=')
  then
     IsLogicOperation:=true
  else
     IsLogicOperation:=false;
end;

function GetConstType(param:string):TTypString;
begin
  if param[1]='"' then
    GetConstType:=c_typ_string
  else if pos('.', param)>0 then
    GetConstType:=c_typ_real
  else
    GetConstType:=c_typ_int;
end;

{ॢ i ᯥii ᨬ  #<祭>}
function ConvertToSpecialChars(s:string):string;
var
   result:string;
   i:integer;
begin
   result:='';
   for i:=1 to length(s) do
     begin
       case s[i] of
         '#':result:=result+'##';
         ' ':result:=result+'#s';
         '=':result:=result+'#e';
         ':':result:=result+'#d';
         '(':result:=result+'#a';
         ')':result:=result+'#f';
         '[':result:=result+'#q';
         ']':result:=result+'#w';
         ';':result:=result+'#k';
         '"':result:=result+'#l';
         ',':result:=result+'#j';
         '+':result:=result+'#1';
         '-':result:=result+'#2';
         '*':result:=result+'#3';
         '/':result:=result+'#4';
        else
         result:=result+s[i];
       end;
     end;
   ConvertToSpecialChars:=result;
end;

{ॢ ᨬ #<祭>  砩i ᨬ}
function ConvertFromSpecialChars(s:string):string;
var
   result:string;
   i:integer;
begin
   result:='';
   i:=0;
   while i<length(s) do
     begin
       inc(i);
       if s[i]='#' then
         begin
           inc(i);
           if i>length(s) then break;
           case s[i] of
             '#':result:=result+'#';
             's':result:=result+' ';
             'e':result:=result+'=';
             'd':result:=result+':';
             'a':result:=result+'(';
             'f':result:=result+')';
             'q':result:=result+'[';
             'w':result:=result+']';
             'k':result:=result+';';
             'l':result:=result+'"';
             'j':result:=result+',';
             '1':result:=result+'+';
             '2':result:=result+'-';
             '3':result:=result+'*';
             '4':result:=result+'/';
           end;
         end
       else
         begin
           result:=result+s[i];
         end;
     end;
   ConvertFromSpecialChars:=result;
end;


{povertaye znachennia strichky v lapkah}
function GetStringZnachennia(s:string):string;
var
  i:integer;
  kilkist:integer;
begin
     if length(s)=0 then
       begin
         GetStringZnachennia:='';
         exit;
       end;
     if (s[1]='"') and (s[length(s)]='"') then
        s:=copy(s, 2, length(s)-2)
     else
        s:='[ERROR]';
                 {++++++++++++++++++++++++++++++++++++++++++++++++++++++
                   Zrobyty zaminu specsymvoliv po typu : " itd
                 }
     GetStringZnachennia:=s;
end;

function GetPointerOfVar(name:string; zminniFirst:TPZminnaZapys):pointer;
var
   p:TPZminnaZapys;
begin
   p:=zminniFirst;
   while p<>nil do
     begin
       if p^.imya^=name then
         begin
           GetPointerOfVar:=p;
           exit;
         end;
       p:=p^.next;
     end;
   GetPointerOfVar:=nil;
end;




end.