unit int_stek;


interface

type
    {stek procedur}
     TPLongintStek=^TLongintStek;
     TLongintStek=record
        val:longint;
        next:TPLongintStek;
     end;

   TPIntStek=^TIntStek;
   TIntStek=record
      val:integer;
      next:TPIntStek;
   end;
   TPRealStek=^TRealStek;
   TRealStek=record
      val:real;
      next:TPRealStek;
   end;
   TPStringStek=^TStringStek;
   TStringStek=record
      val:string;
      next:TPStringStek;
   end;

procedure PushIntStek(var stek:TPIntStek; val:integer);
function PopIntStek(var stek:TPIntStek):integer;
procedure PushLongintStek(var stek:TPLongintStek; val:Longint);
function PopLongintStek(var stek:TPLongintStek):Longint;
procedure PushStringStek(var stek:TPStringStek; val:String);
function PopStringStek(var stek:TPStringStek):String;
procedure PushRealStek(var stek:TPRealStek; val:real);
function PopRealStek(var stek:TPRealStek):real;

implementation


procedure PushIntStek(var stek:TPIntStek; val:integer);
var
   p:TPIntStek;
begin
   GetMem(p, sizeof(TIntStek));
   p^.next:=stek;
   p^.val:=val;
   stek:=p;
end;

function PopIntStek(var stek:TPIntStek):integer;
var
  p:TPIntStek;
begin
  p:=stek;
  PopIntStek:=p^.val;
  stek:=stek^.next;
  FreeMem(p, sizeOf(TIntStek));
end;


procedure PushLongintStek(var stek:TPLongintStek; val:Longint);
var
   p:TPLongintStek;
begin
   GetMem(p, sizeof(TLongintStek));
   p^.next:=stek;
   p^.val:=val;
   stek:=p;
end;

function PopLongintStek(var stek:TPLongintStek):Longint;
var
  p:TPLongintStek;
begin
  p:=stek;
  PopLongintStek:=p^.val;
  stek:=stek^.next;
  FreeMem(p, sizeOf(TLongintStek));
end;


procedure PushStringStek(var stek:TPStringStek; val:String);
var
   p:TPStringStek;
begin
   GetMem(p, sizeof(TStringStek));
   p^.next:=stek;
   p^.val:=val;
   stek:=p;
end;

function PopStringStek(var stek:TPStringStek):String;
var
  p:TPStringStek;
begin
  p:=stek;
  PopStringStek:=p^.val;
  stek:=stek^.next;
  FreeMem(p, sizeOf(TStringStek));
end;


procedure PushRealStek(var stek:TPRealStek; val:real);
var
   p:TPRealStek;
begin
   GetMem(p, sizeof(TRealStek));
   p^.next:=stek;
   p^.val:=val;
   stek:=p;
end;

function PopRealStek(var stek:TPRealStek):real;
var
  p:TPRealStek;
begin
  p:=stek;
  PopRealStek:=p^.val;
  stek:=stek^.next;
  FreeMem(p, sizeOf(TRealStek));
end;



end.