unit int_stpr;

interface

uses
    interp;

function IsStandProc(name:string):integer;
function GetStProcParameters(ID:integer):string;
procedure RunStandProc(ID:integer; var prog:TInterpProg);

implementation

uses
    int_def;


procedure stprAboutText(var prog:TInterpProg);
begin
  prog.OperatorLet('let s="i_᪠-_''⭨_䠩i_i_0.2";');
  prog.KillVar('s');
end;


{AssignFile(var f:textfile;s:string)}
procedure stprAssignFile(var prog:TInterpProg);
var
   p:TPZminnaZapys;
   f:^text;
   filename:^string;
begin
   if prog.fatalError then
     exit;
   p:=GetPointerOfVar('f', prog.zminniFirst);
   if p=nil then
     begin
       prog.fatalError:=true;
       prog.errorStr:='Parametry procedury nevirni';
       exit;
     end;
   f:=p^.znachennia;
   p:=GetPointerOfVar('s', prog.zminniFirst);
   if p=nil then
     begin
       prog.fatalError:=true;
       prog.errorStr:='Parametry procedury nevirni';
       exit;
     end;
   filename:=p^.znachennia;
   assign(f^, filename^);
   prog.KillVar('f');
   prog.KillVar('s');
end;


{rewrite(var f:textfile)}
procedure stprRewrite(var prog:TInterpProg);
var
   p:TPZminnaZapys;
   ftext:^text;
begin
   if prog.fatalError then
     exit;
   p:=GetPointerOfVar('file', prog.zminniFirst);
   if p=nil then
     begin
       prog.fatalError:=true;
       prog.errorStr:='Parametry procedury nevirni';
       exit;
     end;
   ftext:=p^.znachennia;
  {$I-}
   rewrite(ftext^);
   if IOResult<>0 then
     begin
       prog.fatalError:=true;
       prog.errorStr:='Fail ne znaideno';
       exit;
     end;
   prog.KillVar('f');
end;

{reset(var f:textfile)}
procedure stprReset(var prog:TInterpProg);
var
   p:TPZminnaZapys;
   ftext:^text;
begin
   if prog.fatalError then
     exit;
   p:=GetPointerOfVar('f', prog.zminniFirst);
   if p=nil then
     begin
       prog.fatalError:=true;
       prog.errorStr:='Parametry procedury nevirni';
       exit;
     end;
   ftext:=p^.znachennia;
  {$I-}
   reset(ftext^);
   if IOResult<>0 then
     begin
       prog.fatalError:=true;
       prog.errorStr:='Fail ne znaideno';
       exit;
     end;
   prog.KillVar('f');
end;

{append(var f:textfile)}
procedure stprAppend(var prog:TInterpProg);
var
   p:TPZminnaZapys;
   ftext:^text;
begin
   if prog.fatalError then
     exit;
   p:=GetPointerOfVar('f', prog.zminniFirst);
   if p=nil then
     begin
       prog.fatalError:=true;
       prog.errorStr:='Parametry procedury nevirni';
       exit;
     end;
   ftext:=p^.znachennia;
  {$I-}
   append(ftext^);
   if IOResult<>0 then
     begin
       prog.fatalError:=true;
       prog.errorStr:='Fail ne znaideno';
       exit;
     end;
   prog.KillVar('f');
end;


{writeln(var f:textfile;s:string)}
procedure stprWriteln(var prog:TInterpProg);
var
   p:TPZminnaZapys;
   f:^text;
   s:^string;
begin
   if prog.fatalError then
     exit;
   p:=GetPointerOfVar('f', prog.zminniFirst);
   if p=nil then
     begin
       prog.fatalError:=true;
       prog.errorStr:='Parametry procedury nevirni';
       exit;
     end;
   f:=p^.znachennia;
   p:=GetPointerOfVar('s', prog.zminniFirst);
   if p=nil then
     begin
       prog.fatalError:=true;
       prog.errorStr:='Parametry procedury nevirni';
       exit;
     end;
   s:=p^.znachennia;
  {$I-}
   writeln(f^, s^);
   if IOResult<>0 then
     begin
       prog.fatalError:=true;
       prog.errorStr:='Ne moju zapysaty v fail';
       exit;
     end;
   writeln('writetofile');
   prog.KillVar('f');
   prog.KillVar('s');
end;



{CloseFile(var f:textfile)}
procedure stprCloseFile(var prog:TInterpProg);
var
   p:TPZminnaZapys;
   ftext:^text;
begin
   p:=GetPointerOfVar('f', prog.zminniFirst);
   if p=nil then
     begin
       prog.fatalError:=true;
       prog.errorStr:='Parametry procedury nevirni';
       exit;
     end;
   ftext:=p^.znachennia;
  {$I-}
   close(ftext^);
   prog.KillVar('f');
end;

{Povertaye vidyemnyi ID standartnoyi procedury, yakshcho ce vona,
abo 0 yakshcho nema takoyi standartnoyi procedury}
function IsStandProc(name:string):integer;
begin
  IsStandProc:=0;
  if name='AboutText' then IsStandProc:=-1
  else if name='AssignFile' then IsStandProc:=-2
  else if name='rewrite' then IsStandProc:=-3
  else if name='CloseFile' then IsStandProc:=-4
  else if name='reset' then IsStandProc:=-5
  else if name='writeln' then IsStandProc:=-6
  else if name='append' then IsStandProc:=-7;
end;

{Povertaye parametry procedury po ID}
function GetStProcParameters(ID:integer):string;
begin
  case ID of
    -1:GetStProcParameters:='var s:string;s2:string';{AboutText}
    -2:GetStProcParameters:='var f:textfile;s:string';{AssignFile}
    -3:GetStProcParameters:='var f:textfile';{rewrite}
    -4:GetStProcParameters:='var f:textfile';{CloseFile}
    -5:GetStProcParameters:='var f:textfile';{reset}
    -6:GetStProcParameters:='var f:textfile;s:string';{writeln}
    -7:GetStProcParameters:='var f:textfile';{append}
  end;
end;


procedure RunStandProc(ID:integer; var prog:TInterpProg);
begin
  if prog.fatalError then
     exit;
  case ID of
    -1:stprAboutText(prog);
    -2:stprAssignFile(prog);
    -3:stprRewrite(prog);
    -4:stprCloseFile(prog);
    -5:stprReset(prog);
    -6:stprWriteln(prog);
    -7:stprAppend(prog);
  end;
end;


end.